<?php

use SilverStripe\CMS\Model\SiteTree;
use SilverStripe\Forms\GridField\GridField;
use SilverStripe\Forms\GridField\GridFieldConfig_RecordEditor;

use SilverStripe\Forms\GridField\GridFieldConfig_RelationEditor;
use UndefinedOffset\SortableGridField\Forms\GridFieldSortableRows;

use SilverStripe\CMS\Controllers\ContentController;

//has_one Library
use SilverStripe\Assets\Image;
use SilverStripe\Assets\File;
use SilverStripe\AssetAdmin\Forms\UploadField;
use SilverStripe\AssetAdmin\Forms\PreviewImageField;

use SilverStripe\Forms\TextField;
use SilverStripe\Forms\HTMLEditor\HTMLEditorField;

use SilverStripe\Forms\CheckboxField;
use SilverStripe\Forms\DateField;

use SilverStripe\Versioned\Versioned;
use SilverStripe\Control\Controller;

//has_many Library
use SilverStripe\ORM\DataObject;
use SilverStripe\Forms\FieldList;
use SilverStripe\Forms\TextareaField;

//Search
use SilverStripe\ORM\Filters\PartialMatchFilter;
use SilverStripe\ORM\Filters\GreaterThanFilter;
use SilverStripe\ORM\Search\SearchContext;

class GenelgelerItem extends DataObject
{
    private static $db = [
		'Title' => 'Text',
		'Dates' => 'Date',
		'Contents' => 'HTMLText',
		'SortOrder'=>'Int'
	];
	
	private static $has_one = [
        'AddDocs' => File::class,
		'Genelgeler' => Genelgeler::class,
    ];
	
	private static $has_many = [
		
    ];
	
	private static $summary_fields = [
        'Title' => 'Title',
        'Dates' => 'Dates',
        'SortOrder' => 'SortOrder',
    ];
	
	private static $searchable_fields = [
      'Title',
      'Contents'
   ];
	
	private static $owns = [
        'AddDocs',
    ];
	
	private static $default_sort = 'SortOrder';
	
	 public function getCMSFields()
    {
        $fields = parent::getCMSFields();
		
		$fields = FieldList::create(
            $uploader = UploadField::create('AddDocs','Upload Docs (pdf, docs vs..)'),
			
            TextField::create('Title','Page Title'),
			
            HTMLEditorField::create('Contents','Content'),
            DateField::create('Dates', 'Tarih (Gün,Ay,Yıl)'),
			
            TextField::create('SortOrder')
        );

        $uploader->setFolderName('Genelgeler-Dosyalari-image');
        $uploader->getValidator()->setAllowedExtensions(['png','gif','jpeg','jpg']);
		
        return $fields;
    }
	
	private static $extensions = [
        Versioned::class,
    ];
	
	private static $versioned_gridfield_extensions = true;

    public function getGridThumbnail()
    {
        if($this->GenelgelerImg()->exists()) {
            return $this->GenelgelerImg()->ScaleWidth(100);
        }

        return "(no image)";
    }
	
	public function Link()
    {
        return $this->Genelgeler()->Link('show/'.$this->ID .'/'.SiteTree::create()->generateURLSegment($this->Title));
		//return $this->Permalink = SiteTree::create()->generateURLSegment($this->Title);
    }

    public function LinkingMode()
    {
        return Controller::curr()->getRequest()->param('ID') == $this->ID ? 'current' : 'link';
    }

}